image:
  name: didelotkev/wordpress-beanstalk:latest
  entrypoint:
     - '/usr/bin/env'
     - 'PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin'

before_script:
  - cd /usr/src/wordpress/terraform
  - rm -rf .terraform
  - terraform --version
  - export AWS_ACCESS_KEY_ID
  - export AWS_SECRET_ACCESS_KEY
  - export TERRAFORM_TOKEN
  - sed 's/${var.TERRAFORM_TOKEN}/'"$TERRAFORM_TOKEN"'/' .terraformrc.tmp  > .terraformrc
  - terraform init
  

stages:
  - delete
  - validate
  - plan
  - apply
  
delete:
  stage: delete
  script:
    - terraform destroy -var-file=fixtures.eu-central-1.tfvars -auto-approve
  when:
    - manual

validate:
  stage: validate
  script:
    - terraform validate

plan:
  stage: plan
  script:
    - terraform plan -out "planfile" -var-file=fixtures.eu-central-1.tfvars
    - cp ./planfile ${CI_PROJECT_DIR}
  dependencies:
    - validate
  artifacts:
    paths:
      - ${CI_PROJECT_DIR}/planfile

apply:
  stage: apply
  script:
    - apk add --update zip unzip  
    - terraform apply -input=false -auto-approve -target="module.rds_instance" -var-file=fixtures.eu-central-1.tfvars
    - terraform apply -input=false -auto-approve -var-file=fixtures.eu-central-1.tfvars
  dependencies:
    - plan

